; Memtest86+ USB Installer 2010 Lance http://www.pendrivelinux.com (created per request of Samuel DEMEULEMEESTER of Memtest86+ http://www.memtest.org/)
; Syslinux 1994-2009 H. Peter Anvin http://syslinux.zytor.com (unmodified binary used)
; Memtest86+ 2009 http://www.memtest.org (unmodified binary image used)
; Installer Created with NSIS Installer 1995-2009 Contributors http://nsis.sourceforge.net/License
; NSIS Installer 1995-2009 Contributors http://nsis.sourceforge.net/License
; This script originally based on and inspired by Tazusb.exe for Slitaz 2009 Cedric Tissieres (slitaz@objectif-securite.ch) and the USB Boot Tester 2009 Lance http://www.pendrivelinux.com
; You need to install NSIS to compile this script. 

!define NAME "Memtest86+ USB Installer"
!define DISTRO "Boot Files"
!define FILENAME "Memtest86+ USB Installer"
!define VERSION "v0.1"
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\nsis1-install.ico"
RequestExecutionLevel highest 
SetCompressor LZMA
CRCCheck On
XPStyle on
ShowInstDetails show
BrandingText "Memtest86+ USB Installer http://www.memtest.org/"
CompletedText "Installation Done, Your Drive should be ready to boot!"
InstallButtonText Create

Name "${NAME} ${VERSION}"
OutFile "${FILENAME}.exe"

!include "MUI2.nsh"
!include "FileFunc.nsh"

; Interface settings
!define MUI_FINISHPAGE_NOAUTOCLOSE
!define MUI_HEADERIMAGE
!define MUI_HEADERIMAGE_BITMAP "usb-logo-nsis.bmp" 
!define MUI_HEADERIMAGE_BITMAP_NOSTRETCH
!define MUI_HEADERIMAGE_RIGHT

; License page
!define MUI_TEXT_LICENSE_SUBTITLE $(License_Subtitle)
!define MUI_LICENSEPAGE_TEXT_TOP $(License_Text_Top)
!define MUI_LICENSEPAGE_TEXT_BOTTOM $(License_Text_Bottom)
!insertmacro MUI_PAGE_LICENSE "license.txt"

; Drive page
Var DestDriveTxt
Var DestDrive
Var DestDisk
Var LabelDrivePageText
Var LabelDriveSelect
Var Format
Var FormatMe
Var Warning
Page custom drivePage

; Instfiles page
!define MUI_INSTFILESPAGE_COLORS "00FF00 000000" ;Green and Black
!define MUI_TEXT_INSTALLING_TITLE $(Install_Title)
!define MUI_TEXT_INSTALLING_SUBTITLE $(Install_SubTitle)
!define MUI_TEXT_FINISH_SUBTITLE $(Install_Finish_Sucess)
!insertmacro MUI_PAGE_INSTFILES

; Finish page
!define MUI_FINISHPAGE_TITLE $(Finish_Title)
!define MUI_FINISHPAGE_TEXT $(Finish_Text)
!define MUI_FINISHPAGE_LINK $(Finish_Link)
!define MUI_FINISHPAGE_LINK_LOCATION "http://www.memtest.org/"
!insertmacro MUI_PAGE_FINISH
  
; Language files
!insertmacro MUI_LANGUAGE "English" ;first language is the default language

; English
LangString License_Subtitle ${LANG_ENGLISH} "Please review the license terms before running ${NAME}."
LangString License_Text_Top ${LANG_ENGLISH} "The software within this program falls under the following License."
LangString License_Text_Bottom ${LANG_ENGLISH} "You must accept the terms of this License agreement to run ${NAME}. If you agree, Click I Agree to Continue."
LangString Finish_Title ${LANG_ENGLISH} "${NAME} has completed the installation."
LangString Finish_Text ${LANG_ENGLISH} "The necessary files are installed on your USB drive and the drive is bootable.$\r$\n$\r$\nNow you should proceed to see if it boots"
LangString Finish_Link ${LANG_ENGLISH} "Visit the Official Memtest86+ Site"
LangString DrivePage_Title ${LANG_ENGLISH} "Choose USB drive location"
LangString DrivePage_Title2 ${LANG_ENGLISH} "Choose the USB drive in which to make bootable."
LangString DrivePage_Text ${LANG_ENGLISH} "Please select your USB Flash Drive and Format option. ${NAME} will proceed to make this drive Bootable and install the Memtest86+ tool on it."
LangString DrivePage_Input ${LANG_ENGLISH} "Select your USB Flash Drive"
LangString WarningPage_Text ${LANG_ENGLISH} "WARNING!! Contents on this Drive will be deleted. Any exisiting MBR WILL be overwritten. Make sure you have backed up any important content!$\r$\n$\r$\nWhen you are sure, click Create to proceed."
LangString Syslinux_Creation ${LANG_ENGLISH} "Create syslinux configuration and moving files to $DestDrive"
LangString Syslinux_Execution ${LANG_ENGLISH} "Execute syslinux on $R0"
LangString Syslinux_Warning ${LANG_ENGLISH} "An error ($R8) occurred while executing syslinux.$\r$\nYour USB drive won't be bootable..."
LangString Install_Title ${LANG_ENGLISH} "Installing ${DISTRO}"
LangString Install_SubTitle ${LANG_ENGLISH} "Please wait while ${NAME} installs ${DISTRO} on $0"
LangString Install_Finish_Sucess ${LANG_ENGLISH} "${NAME} sucessfully installed ${DISTRO} on $0"

Function drivePage
  !insertmacro MUI_HEADER_TEXT $(DrivePage_Title) $(DrivePage_Title2)
  nsDialogs::Create 1018
  ${If} $DestDrive == ""
  GetDlgItem $6 $HWNDPARENT 1 ; Get next control handle
  EnableWindow $6 0 ; disable next 
  ${EndIf}
  ${NSD_CreateLabel} 0 0 100% 30 $(DrivePage_Text)
  Pop $LabelDrivePageText
  ${NSD_CreateLabel} 0 50 100% 15 $(DrivePage_Input)
  Pop $LabelDriveSelect
  ${NSD_CreateDroplist} 0 68 23% 20 ""
  Pop $DestDriveTxt
  ${NSD_OnChange} $DestDriveTxt db_select.onchange
  ${GetDrives} "FDD" driveList
  ${If} $DestDrive != ""
  ${NSD_CB_SelectString} $DestDriveTxt $DestDrive
  ${EndIf}
; Format Drive Option
  ${NSD_CreateCheckBox} 25% 68 75% 15 "Check this box if you want to format the Drive."
  Pop $Format
  ${NSD_OnClick} $Format FormatIt
; Warning Label  
  ${NSD_CreateLabel} 0 120 100% 60 $(WarningPage_Text)
  Pop $Warning  
  EnableWindow $Format 0 
  ShowWindow $Warning 0   
  GetDlgItem $6 $HWNDPARENT 3  
  ShowWindow $6 0 ; Disable Back 
  nsDialogs::Show
FunctionEnd

Function db_select.onchange
  Pop $DestDriveTxt
  ${NSD_GetText} $DestDriveTxt $0
  StrCpy $DestDrive "$0"
  StrCpy $DestDisk $DestDrive -1  
  GetDlgItem $6 $HWNDPARENT 1 ; Get "Next" control handle
  EnableWindow $6 1 ; enable "Next" control
  EnableWindow $Format 1  
  ShowWindow $Warning 1
  SetCtlColors $Warning /Branding FF0000
  Call FormatIt
FunctionEnd

Function driveList
	SendMessage $DestDriveTxt ${CB_ADDSTRING} 0 "STR:$9"
	Push 1
FunctionEnd

Function FormatIt ; Set Format Option
  ${NSD_GetState} $Format $FormatMe
  ${If} $FormatMe == ${BST_CHECKED}
  ${NSD_Check} $Format
  StrCpy $FormatMe "Yes"
  ${NSD_SetText} $Format "We will format $DestDrive as Fat32."
  ${ElseIf} $FormatMe == ${BST_UNCHECKED}
  ${NSD_Uncheck} $Format 
  ${NSD_SetText} $Format "(Recommended) Check this box if you want to format Drive $DestDrive"  
  ${EndIf}  
FunctionEnd

Function FormatYes ; If Format is checked, do something
  ${If} $FormatMe == "Yes" 
  DetailPrint "Formatting $DestDisk"
  nsExec::ExecToLog '"cmd" /c "format $DestDisk /FS:Fat32 /V:MULTIBOOT /Q /y"'  
  ${EndIf} 
FunctionEnd 

Section "Copyfiles" main
  Call FormatYes ; Format the Drive?
  InitPluginsDir
  File /oname=$PLUGINSDIR\syslinux.exe "syslinux.exe"
  File /oname=$PLUGINSDIR\syslinux.cfg "syslinux.cfg"
  File /oname=$PLUGINSDIR\mt86plus "mt86plus"  
  File /oname=$PLUGINSDIR\Readme.txt "Readme.txt"  
  File /oname=$PLUGINSDIR\Copying "Copying"   
  SetShellVarContext all

; Execute syslinux on the drive
  StrCpy $R0 $DestDrive -1 ; remove \ for syslinux
  ClearErrors
  DetailPrint $(Syslinux_Execution)
   	ExecWait '$PLUGINSDIR\syslinux.exe -maf $R0' $R8
  	DetailPrint "Return $R8"
    Banner::destroy
	${If} $R8 != 0
    MessageBox MB_ICONEXCLAMATION|MB_OK $(Syslinux_Warning)
  ${EndIf}
  
; Create files
  Var /GLOBAL BootDir
  StrCpy $BootDir $DestDrive -1 
  StrCpy $BootDir "$BootDir"

  DetailPrint $(Syslinux_Creation) 
  CopyFiles "$PLUGINSDIR\syslinux.cfg" "$BootDir\syslinux.cfg" ; move syslinux.cfg
  CopyFiles "$PLUGINSDIR\mt86plus" "$BootDir\mt86plus" ; move memtest
  CopyFiles "$PLUGINSDIR\Readme.txt" "$BootDir\Readme.txt" ; move Readme
  CopyFiles "$PLUGINSDIR\Copying" "$BootDir\Copying" ; move Copying 
SectionEnd